LoadBalancerDrainingValve (Apache Tomcat 9.0.71 API Documentation)

Package org.apache.catalina.valves

## Class LoadBalancerDrainingValve

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.valves.ValveBase
      - - org.apache.catalina.valves.LoadBalancerDrainingValve

- All Implemented Interfaces:
    `javax.management.MBeanRegistration`, `Contained`, `JmxEnabled`, `Lifecycle`, `Valve`

      public class LoadBalancerDrainingValve
      extends ValveBase

  A Valve to detect situations where a load-balanced node receiving a request has been deactivated by the load balancer (JK_LB_ACTIVATION=DIS) and the incoming request has no valid session.

  In these cases, the user's session cookie should be removed if it exists, any ";jsessionid" parameter should be removed from the request URI, and the client should be redirected to the same URI. This will cause the load-balanced to re-balance the client to another server.

  All this work is required because when the activation state of a node is DISABLED, the load-balancer will still send requests to the node if they appear to have a session on that node. Since mod_jk doesn't actually know whether the session id is valid, it will send the request blindly to the disabled node, which makes it take much longer to drain the node than strictly necessary.

  For testing purposes, a special cookie can be configured and used by a client to ignore the normal behavior of this Valve and allow a client to get a new session on a DISABLED node. See `setIgnoreCookieName(java.lang.String)` and `setIgnoreCookieValue(java.lang.String)` to configure those values.

  This Valve should be installed earlier in the Valve pipeline than any authentication valves, as the redirection should take place before an authentication valve would save a request to a protected resource.

  See Also:
    Load balancer documentation

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

      `Lifecycle.SingleUse`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ATTRIBUTE_KEY_JK_LB_ACTIVATION` | The request attribute key where the load-balancer's activation state can be found.

    - ### Fields inherited from class org.apache.catalina.valves.ValveBase

      `asyncSupported, container, containerLog, next, sm`

    - ### Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `mserver`

    - ### Fields inherited from interface org.apache.catalina.Lifecycle

      `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `LoadBalancerDrainingValve()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getIgnoreCookieName()` | Gets the name of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state.
    `java.lang.String` | `getIgnoreCookieValue()` | Gets the expected value of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state.
    `void` | `invoke​(Request request, Response response)` | Perform request processing as required by this Valve.
    `void` | `setIgnoreCookieName​(java.lang.String cookieName)` | Sets the name of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state.
    `void` | `setIgnoreCookieValue​(java.lang.String cookieValue)` | Sets the expected value of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state.
    `void` | `setRedirectStatusCode​(int code)` | Sets the HTTP response code that will be used to redirect the request back to the load-balancer for re-balancing.

    - ### Methods inherited from class org.apache.catalina.valves.ValveBase

      `backgroundProcess, getContainer, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setContainer, setNext, startInternal, stopInternal, toString`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister, unregister`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleBase

      `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, getThrowOnFailure, init, removeLifecycleListener, setState, setState, setThrowOnFailure, start, stop`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ATTRIBUTE_KEY_JK_LB_ACTIVATION

          public static final java.lang.String ATTRIBUTE_KEY_JK_LB_ACTIVATION

      The request attribute key where the load-balancer's activation state can be found.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### LoadBalancerDrainingValve

          public LoadBalancerDrainingValve()

  - ### Method Detail

    - #### setRedirectStatusCode

          public void setRedirectStatusCode​(int code)

      Sets the HTTP response code that will be used to redirect the request back to the load-balancer for re-balancing. Defaults to 307 (TEMPORARY_REDIRECT).
      Parameters:
        `code` - The code to use for the redirect

    - #### getIgnoreCookieName

          public java.lang.String getIgnoreCookieName()

      Gets the name of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state.
      Returns:
        The cookie name used to ignore normal processing rules.
      See Also:
        `setIgnoreCookieValue(java.lang.String)`

    - #### setIgnoreCookieName

          public void setIgnoreCookieName​(java.lang.String cookieName)

      Sets the name of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state. There is no default value for this setting: the ability to override the re-balancing behavior of this Valve is disabled by default.
      Parameters:
        `cookieName` - The cookie name to use to ignore normal processing rules.
      See Also:
        `getIgnoreCookieValue()`

    - #### getIgnoreCookieValue

          public java.lang.String getIgnoreCookieValue()

      Gets the expected value of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state.
      Returns:
        The cookie value used to ignore normal processing rules.
      See Also:
        `setIgnoreCookieValue(java.lang.String)`

    - #### setIgnoreCookieValue

          public void setIgnoreCookieValue​(java.lang.String cookieValue)

      Sets the expected value of the cookie that can be used to override the re-balancing behavior of this Valve when the current node is in the DISABLED activation state. The "ignore" cookie's value must be exactly equal to this value in order to allow the client to override the re-balancing behavior.
      Parameters:
        `cookieValue` - The cookie value to use to ignore normal processing rules.
      See Also:
        `getIgnoreCookieValue()`

    - #### invoke

          public void invoke​(Request request,
                             Response response)
                      throws java.io.IOException,
                             ServletException

      Description copied from interface: `Valve`

      Perform request processing as required by this Valve.

      An individual Valve MAY perform the following actions, in the specified order:

      - Examine and/or modify the properties of the specified Request and Response.
      - Examine the properties of the specified Request, completely generate the corresponding Response, and return control to the caller.
      - Examine the properties of the specified Request and Response, wrap either or both of these objects to supplement their functionality, and pass them on.
      - If the corresponding Response was not generated (and control was not returned, call the next Valve in the pipeline (if there is one) by executing `getNext().invoke()`.
      - Examine, but not modify, the properties of the resulting Response (which was created by a subsequently invoked Valve or Container).

      A Valve MUST NOT do any of the following things:

      - Change request properties that have already been used to direct the flow of processing control for this request (for instance, trying to change the virtual host to which a Request should be sent from a pipeline attached to a Host or Context in the standard implementation).
      - Create a completed Response AND pass this Request and Response on to the next Valve in the pipeline.
      - Consume bytes from the input stream associated with the Request, unless it is completely generating the response, or wrapping the request before passing it on.
      - Modify the HTTP headers included with the Response after the `getNext().invoke()` method has returned.
      - Perform any actions on the output stream associated with the specified Response after the `getNext().invoke()` method has returned.
      Parameters:
        `request` - The servlet request to be processed
        `response` - The servlet response to be created
      Throws:
        `java.io.IOException` - if an input/output error occurs, or is thrown by a subsequently invoked Valve, Filter, or Servlet
        `ServletException` - if a servlet error occurs, or is thrown by a subsequently invoked Valve, Filter, or Servlet